# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_repolib 1
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/org/%{name}/%{name}/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define _without_gcj_support 1
%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section     free

%define maven_settings_file %{_builddir}/%{name}/settings.xml

%define reltag .redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

Name:           scannotation
Version:        1.0.2
Release:        4%{reltag}%{?dist}
Epoch:          0
Summary:        Small Java library to help your projects scan jars and classpaths for annotations and create an index of these annotations
License:        Apache License V2.0
Group:          Development/Java
URL:            http://scannotation.sourceforge.net/
#svn export https://scannotation.svn.sourceforge.net/svnroot/scannotation scannotation
#tar zcvf scannotation-1.0.2.tar.gz scannotation/
Source0:        scannotation-%{version}.tar.gz
Source1:        %{name}-jpp-depmap.xml
Source2:        %{name}-settings.xml
Source5:	    %{name}-component-info.xml
Source6: 	scannotation-upload.sh

Patch0:         scannotation-pom-vman.patch
#Patch1:         scannotation-scannotation-pom_xml.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRequires:  jpackage-utils >= 0:1.7.2
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven2 >= 2.0.4-10
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-surefire-report
BuildRequires:  maven2-common-poms >= 1.0
BuildRequires:  log4j
BuildRequires:  junit
BuildRequires:  javassist
BuildRequires:  geronimo-servlet-2.5-api

Requires(post):    jpackage-utils >= 0:1.7.2
Requires(postun):  jpackage-utils >= 0:1.7.2

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

%description
Scannotation is a Java library that creates an annotation database from a set of .class files. This database is really just a set of maps that index what annotations are used and what classes are using them. Why do you need this? What if you are an annotation framework like an EJB 3.0 container and you want to automatically scan your classpath for EJB annotations so that you know what to deploy? Scannotation gives you apis that allow you to find archives in your classpath or WAR (web application) that you want to scan, then automatically scans them without loading each and every class within those archives

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -q -n %{name}
%patch0 -p1
#%patch1

find . -name "*.jar" -exec rm -f {} \;

#sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' %{SOURCE2}
#tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
#sed -i "s/@TAG@/$tag/g" %{SOURCE2}

%build

cp %{SOURCE2} settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

#export M2SETTINGS=$(pwd)/settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/

mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.mode=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.skip=true \
        -DaltDeploymentRepository=oss-releases::default::file:maven2-brew \
        javadoc:aggregate install deploy:deploy

%install
rm -rf $RPM_BUILD_ROOT

ls -lR

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -pm 644 scannotation/target/scannotation-%{namedversion}.jar \
          $RPM_BUILD_ROOT%{_javadir}/
install -pm 644 scannotation/target/scannotation-%{namedversion}-sources.jar \
          $RPM_BUILD_ROOT%{_javadir}/

%add_to_maven_depmap org.%{name} %{name} %{namedversion} JPP %{name}

(cd $RPM_BUILD_ROOT%{_javadir} && ln -sf scannotation-%{namedversion}.jar scannotation.jar)
(cd $RPM_BUILD_ROOT%{_javadir} && ln -sf scannotation-%{namedversion}-sources.jar scannotation-sources.jar)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{namedversion}/
%{__ln_s} %{name}-%{namedversion} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 scannotation/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif


%if %{with_repolib}
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%{_javadir}*/scannotation.jar
%{_javadir}*/scannotation-%{namedversion}.jar
%{_javadir}*/scannotation-sources.jar
%{_javadir}*/scannotation-%{namedversion}-sources.jar
%{_datadir}/maven2
%{_mavendepmapfragdir}

%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/{%name}-%{namedversion}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Apr 12 2012 Yong Yang <yyang@redhat.com> - 0:1.0.2-4.redhat_1
- Build against target jb-eap-6-rhel-6-candidate
- Correct release

* Thu Apr 12 2012 Yong Yang <yyang@redhat.com> - 0:1.0.2-3.2.2_redhat_1.4
- Correct release

* Thu Apr 12 2012 Yong Yang <yyang@redhat.com> - 0:1.0.2-3.2.2_redhat_1.3
- Bump release to build against target jb-eap-6-devel-rhel-6-candidate

* Thu Apr 12 2012 Yong Yang <yyang@redhat.com> - 0:1.0.2-3.2.2_redhat_1.2
- Update vman patch to correct javax.servlet groupId and artifactId

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.2-3.2.2_redhat_1.1
- Rebuild using cache signing

* Tue Dec 13 2011 Yong Yang <yyang@redhat.com> - 0:1.0.2-3.2.2_redhat_1
- Build for werewolf
- Patch to change javassist groupId
- Add sources jar

* Tue Jan 25 2011 Yiqiao Wang <yiwang@redhat.com> - 0:1.0.2-3.2.1
- Rebuild

* Wed Nov 24 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.0.2-3.2
- Build with Maven 2.2.1
- Add upload.sh to repolib
- Fix %%files for signed jars
- Add content of maven2-brew, add BR mavne-deploy-plugin
- Add the line to find and remove any binaries

* Mon Jun 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.2-3.1
- Fix Release tag

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.2-2.2.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.0.2-2.2
- Rebuild

* Wed Feb 03 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.0.2-2.1
- Disable aot Compiler

* Tue Dec 15 2009 Yong Yang <yyang@redhat.com> 0:1.0.2-2
- Add repolib

* Mon Nov 02 2009 Yong Yang <yyang@redhat.com> 0:1.0.2-1
- First release
